unit Controller;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JvComponentBase, JvHidControllerClass, StdCtrls, ExtCtrls,
  JvThreadTimer;

type
  TForm1 = class(TForm)
    hid: TJvHidDeviceController;
    Memo1: TMemo;
    Button1: TButton;
    SelTimer: TTimer;
    BuzzerTimer: TJvThreadTimer;
    Label1: TLabel;
    ButtonsPressedT: TJvThreadTimer;
    Button2: TButton;
    procedure hidArrival(HidDev: TJvHidDevice);
    procedure SelTimerTimer(Sender: TObject);
    procedure FlashButton(channel:byte);
    procedure UnFlashButton(channel:byte);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BuzzerTimerTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ButtonsPressedTTimer(Sender: TObject);
    procedure Button2Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowRead(HidDev: TJvHidDevice; ReportID: Byte; const Data: Pointer; Size: Word);
    procedure BuzzerReset;
    function QuickestBuzzer:integer;
  end;

TYPE TBuzzButton = Record
   Buzzer:Boolean;
   Blue:Boolean;
   Orange:Boolean;
   Green:Boolean;
   Yellow:Boolean;
   MilliSeconds:longint;
   Pressed:Boolean;
End;

  var
  Form1: TForm1;
  Dev:TJvHidDevice;
  BuzzCTRL:Array[1..4] of TBuzzButton;
  flashchannel:integer;
  Buf: array[0..64] of byte;
  okaytopress:boolean;
  buzzchannel:integer;
  numplayers:integer;
  buzztime:longint;
  maxbuzztime:integer;
  afterbuzztime:integer;
  maxafterbuzztime:integer;
  afterbuzzon:boolean;
implementation

uses MainScreen;

{$R *.dfm}

function Tform1.QuickestBuzzer:integer;
var selected,testtime:longint;
  i: Integer;
begin
    testtime := 1000000001;
    selected := 0;
    for i := 1 to 4 do
    begin
       if ((buzzctrl[i].Pressed) and  (BuzzCTRL[i].MilliSeconds < testtime)) then
       begin
         selected := i;
         testtime := BuzzCTRL[i].MilliSeconds;
       end;
    end;

    Result := selected;

end;

procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
begin
  SelTimer.enabled := false;
  UnflashButton(flashchannel);


   maxbuzztime := 500;
   numplayers := 4;
   buzzerreset;
   okaytopress := true;
   Buzztime := 0;
           BuzzerTimer.Enabled := true;
                   ButtonsPressedT.Enabled := true;
      memo1.lines.add('Buzzer Reset');


end;

procedure TForm1.BuzzerReset;
var
  i: Integer;
begin
  for i := 1 to 4 do
  begin
    buzzctrl[i].Pressed := false;
    buzzctrl[i].MilliSeconds := 10000000;
  end;

end;

procedure TForm1.BuzzerTimerTimer(Sender: TObject);
var i:integer;
    buttonspressed:integer;
  
begin
    label1.caption := inttostr(buzztime);
    if buzzchannel > numplayers then buzzchannel := 1;

    flashbutton(buzzchannel);

     if okaytopress then
     begin
         if not buzzctrl[buzzchannel].Pressed then
         begin
           if buzzctrl[buzzchannel].Buzzer then
           begin

             buzzctrl[buzzchannel].Pressed := true;
             buzzctrl[buzzchannel].MilliSeconds := buzztime;

             form2.media.FileName := form2.SolUtil1.StartDir+'\sounds\buzzer.wav';
             form2.media.Open;
             form2.media.Rewind;
             form2.media.Play;
           end;
         end;
     end;

     if afterbuzzon then
     begin
       afterbuzztime := afterbuzztime + 1;
     end;



     inc(buzzchannel);
     buzztime := buzztime + 1;

end;

procedure TForm1.FlashButton(channel: Byte);
  var ToWrite:Cardinal;
     i:integer;

     dummy:cardinal;
begin
if ((channel > 0) and (channel < 5)) then
begin
try
ToWrite := Dev.Caps.OutputReportByteLength;
    Buf[0] := 0;
   for I := 1 to ToWrite - 1 do
    begin
     Buf[I+1] := StrToIntDef('$' + '00', 0);
  end;

   Buf[channel+1] := 255;


    Dev.WriteFile(buf, ToWrite,dummy);
except
on e:exception do ShowMessage('Is your buzz controller plugged in?');

end;
end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var i:integer;
begin
  for i := 1 to 4 do unflashbutton(i);
end;



procedure TForm1.UnFlashButton(channel: Byte);
  var ToWrite:Cardinal;
     i:integer;
     Buf: array[0..64] of byte;
     dummy:cardinal;
begin
  try
ToWrite := Dev.Caps.OutputReportByteLength;
    Buf[0] := 0;
   for I := 1 to ToWrite - 1 do
    begin
     Buf[I+1] := StrToIntDef('$' + '00', 0);
   end;

   Buf[channel+1] := 0;


    Dev.WriteFile(buf, ToWrite,dummy);
  except
     on e:exception do
     Showmessage('Is your BUZZ Controller Plugged in?');
  end;
end;




procedure TForm1.ShowRead(HidDev: TJvHidDevice; ReportID: Byte;
  const Data: Pointer; Size: Word);
var
  I: Integer;
  Str: string;
  total:integer;
begin
  if okaytopress then
  begin

  total := 0;
  for I := 0 to Size - 1 do
    total := total shl 8 + Cardinal(PChar(Data)[I]);
    total := total  - 240;




  str := '';

  //CTRL2 Green
  if (Total DIV 8388608) = 1 then BuzzCtrl[2].Green := True else BuzzCtrl[2].Green := False;
  Total := Total MOD 8388608;
  if BuzzCtrl[2].Green then str := str + '2G ';


   if (Total div 4194304) = 1  then BuzzCtrl[2].Yellow := True else BuzzCtrl[2].Yellow := False;
  Total := Total MOD 4194304;
  if BuzzCtrl[2].Yellow then str := str + '2Y ';

  if (Total div 2097152) = 1  then BuzzCtrl[2].Buzzer := True else BuzzCtrl[2].Buzzer := False;
  Total := Total MOD 2097152;
  if BuzzCtrl[2].Buzzer then str := str + '2BZ ';

  if (Total div 1048576) = 1  then BuzzCtrl[1].Blue := True else BuzzCtrl[1].Blue := False;
  Total := Total MOD 1048576;
  if BuzzCtrl[1].Blue then str := str + '1B ';

  if (Total div 524288) = 1  then BuzzCtrl[1].Orange := True else BuzzCtrl[1].Orange := False;
  Total := Total MOD 524288;
  if BuzzCtrl[1].Orange then str := str + '1O ';

  if (Total div 262144) = 1  then BuzzCtrl[1].Green := True else BuzzCtrl[1].Green := False;
  Total := Total MOD 262144;
  if BuzzCtrl[1].Green then str := str + '1G ';

  if (Total div 131072) = 1  then BuzzCtrl[1].Yellow := True else BuzzCtrl[1].Yellow := False;
  Total := Total MOD 131072;
  if BuzzCtrl[1].Yellow then str := str + '1Y ';

  if (Total div 65536) = 1  then BuzzCtrl[1].Buzzer := True else BuzzCtrl[1].Buzzer := False;
  Total := Total MOD 65536;
  if BuzzCtrl[1].Buzzer then str := str + '1BZ ';

  if (Total div 32768) = 1  then BuzzCtrl[4].Buzzer := True else BuzzCtrl[4].Buzzer := False;
  Total := Total MOD 32768;
  if BuzzCtrl[4].Buzzer then str := str + '4BZ ';

  if (Total div 16384) = 1  then BuzzCtrl[3].Blue := True else BuzzCtrl[3].Blue := False;
  Total := Total MOD 16384;
  if BuzzCtrl[3].Blue then str := str + '3B ';

  if (Total div 8192) = 1  then BuzzCtrl[3].Orange := True else BuzzCtrl[3].Orange := False;
  Total := Total MOD 8192;
  if BuzzCtrl[3].Orange then str := str + '3O ';

  if (Total div 4096) = 1  then BuzzCtrl[3].Green := True else BuzzCtrl[3].Green := False;
  Total := Total MOD 4096;
  if BuzzCtrl[3].Green then str := str + '3G ';

  if (Total div 2048) = 1  then BuzzCtrl[3].Yellow := True else BuzzCtrl[3].Yellow := False;
  Total := Total MOD 2048;
  if BuzzCtrl[3].Yellow then str := str + '3Y ';

  if (Total div 1024) = 1  then BuzzCtrl[3].Buzzer := True else BuzzCtrl[3].Buzzer := False;
  Total := Total MOD 1024;
  if BuzzCtrl[3].Buzzer then str := str + '3BZ ';

  if (Total div 512) = 1  then BuzzCtrl[2].Blue := True else BuzzCtrl[2].Blue := False;
  Total := Total MOD 512;
  if BuzzCtrl[2].Blue then str := str + '2B ';

  if (Total div 256) = 1  then BuzzCtrl[2].Orange := True else BuzzCtrl[2].Orange := False;
  Total := Total MOD 256;
  if BuzzCtrl[2].Orange then str := str + '2O ';

  if (Total div 8) = 1  then BuzzCtrl[4].Blue := True else BuzzCtrl[4].Blue := False;
  Total := Total MOD 8;
  if BuzzCtrl[4].Blue then str := str + '4B ';

  if (Total div 4) = 1  then BuzzCtrl[4].Orange := True else BuzzCtrl[4].Orange := False;
  Total := Total MOD 4;
  if BuzzCtrl[4].Orange then str := str + '4O ';

  if (Total div 2) = 1  then BuzzCtrl[4].Green := True else BuzzCtrl[4].Green := False;
  Total := Total MOD 2;
  if BuzzCtrl[4].Green then str := str + '4G ';

  if (Total div 1) = 1  then BuzzCtrl[4].Yellow := True else BuzzCtrl[4].Yellow := False;
  Total := Total MOD 8;
  if BuzzCtrl[4].Yellow then str := str + '4Y ';

   memo1.lines.add(str);




  end;
 {    for i := 1 to 4 do unflashbutton(i);

  if BuzzCtrl[1].Buzzer then flashchannel := 1;
  if BuzzCtrl[2].Buzzer then flashchannel := 2;
if BuzzCtrl[3].Buzzer then flashchannel := 3;
if BuzzCtrl[4].Buzzer then flashchannel := 4;

flashbutton(flashchannel);

SelTimer.interval := 1;}









end;

procedure TForm1.SelTimerTimer(Sender: TObject);
begin


   if flashchannel <> 0 then
   begin

    seltimer.Interval := seltimer.interval +3;

    if seltimer.interval < 50 then seltimer.interval := 50;



    if odd(seltimer.interval) then FlashButton(flashchannel) else UnFlashButton(flashchannel);
   end
   else
      begin
       UnflashButton(1);
       UnflashButton(2);
UnflashButton(3);
UnflashButton(4);


      end;

end;

procedure TForm1.hidArrival(HidDev: TJvHidDevice);
var i:integer;
begin
  memo1.lines.add(hiddev.productname);
  if hiddev.ProductName = 'Buzz' then
  begin
   while  Hid.CheckOut(hidDev) do
   begin
     Dev := TJvHidDevice(hiddev);
       Dev.NumInputBuffers := 128;
    Dev.NumOverlappedBuffers := 128;
      Dev.OnData := showread;
     end;

   for i := 1 to 4 do unflashbutton(i);
  end;


end;

procedure TForm1.Button2Click(Sender: TObject);
var ok:boolean;
    amaxbuzztime,abuzztime,selected:integer;
begin
  SelTimer.enabled := true;
  ok := false;
  flashButton(flashchannel);
   Buttonspressedt.Enabled := false;
   buzzertimer.enabled := false;

   amaxbuzztime := 500000;
   okaytopress := true;
   aBuzztime := 0;
   selected := 0;

   while not ok do
   begin
       if buzzctrl[flashchannel].Blue then begin ok := true; selected := 1; end;
       if buzzctrl[flashchannel].Orange then begin ok := true; selected := 2; end;
       if buzzctrl[flashchannel].Green then begin ok := true; selected := 3; end;
       if buzzctrl[flashchannel].Yellow then begin ok := true; selected := 4; end;

       application.processmessages;

       inc(abuzztime);
   end;

      memo1.lines.add('Selected '+inttostr(selected));

      seltimer.Enabled := false;
      unflashbutton(flashchannel);
      okaytopress := false;

end;

procedure TForm1.ButtonsPressedTTimer(Sender: TObject);
Var ButtonsPressed,i:integer;
begin
   ButtonsPressed := 0;
   flashchannel := -1;
     for i := 1 to numplayers do
     begin
       if buzzctrl[i].Pressed then inc(ButtonsPressed);
     end;

     for i := 1 to 4 do UnFlashButton(i);

     if ((buttonspressed > 0) and (afterbuzzon = false)) then
     begin
        afterbuzztime := 0;
        afterbuzzon := true;

     end;

     If ((ButtonsPressed >= NumPlayers) or (buzztime > maxbuzztime) or (afterbuzztime > maxafterbuzztime)) then
     begin

        BuzzerTimer.Enabled := false;
        ButtonsPressedT.Enabled := false;
        okaytopress := false;
               If buttonspressed <> 0 then
               begin
        flashchannel := QuickestBuzzer;
        flashbutton(flashchannel);
          SelTimer.enabled := true;
          memo1.lines.add('Quickest Buzzer'+inttostr(quickestbuzzer));
        memo1.lines.add('Buzzer 1: '+booltostr(buzzctrl[1].Pressed)+'('+inttostr(Buzzctrl[1].MilliSeconds)+')');
        memo1.lines.add('Buzzer 2: '+booltostr(buzzctrl[2].Pressed)+'('+inttostr(Buzzctrl[2].MilliSeconds)+')');
        memo1.lines.add('Buzzer 3: '+booltostr(buzzctrl[3].Pressed)+'('+inttostr(Buzzctrl[3].MilliSeconds)+')');
        memo1.lines.add('Buzzer 4: '+booltostr(buzzctrl[4].Pressed)+'('+inttostr(Buzzctrl[4].MilliSeconds)+')');
           end;
     end;

end;

end.
